/* Remember to change LED_COUNT to the number of led's on your strip, currently set to 14.
   Pin 2 to ground will pause at the color
   Pin 3 to ground will cycle the colours slower - PIN 3 High (default) will cycle fast.
*/


#include <EEPROM.h>
#include <FastLED.h>
#define DATA_PIN 12
#define LED_COUNT 12 //104
#define COLOR_ORDER GRB

int colour_buttonPin = 2;     // Pause the colours
int colour_buttonState = 0;

int speed_buttonPin = 3; // Speed button
int speed_buttonState = 0;

bool paused = false;
byte colour_state = '0';

bool is_red = true;
bool is_blue = false;
bool is_green = false;
bool is_green_2 = false;
bool is_yellow = false;
bool is_yellow_2 = false;
int colorStep = 0;
int r;
int g;
int b;
int delay_speed;
int counter;

CRGB leds[LED_COUNT];

void setup() {
  Serial.begin(9600);

  delay_speed = 50;

  FastLED.addLeds<WS2812, DATA_PIN, GRB>(leds, LED_COUNT);

  pinMode(colour_buttonPin, INPUT_PULLUP);

  pinMode(speed_buttonPin, INPUT_PULLUP);


}

void loop() {
  Serial.print("Colour state: "); Serial.print(colour_state); Serial.print(" - Paused: "); Serial.print(paused); Serial.print(" - colour_buttonState: "); Serial.print(colour_buttonState); Serial.print(" - Delay Speed: "); Serial.println(delay_speed);
  colour_buttonState = digitalRead(colour_buttonPin);
  speed_buttonState = digitalRead(speed_buttonPin);

  if (speed_buttonState == LOW) {
    delay(500);
    if (colour_state == 5) colour_state = 0;
    else
      colour_state = colour_state + 1;
    if ( (colour_state % 2) == 0) {
      colorStep = 0;
    }
    else
      colorStep = 255;

  }
  if (colour_buttonState == LOW) {
    delay(500);
    if (!paused) {
      FastLED.clear();
      paused = true;
    } else {
      FastLED.show();
      paused = false;
    }

  }
  else {

    // RED -> PURPLE
    if (is_red == true) {
      colour_state = 0;
      if (colorStep <= 255) {
        r = 255;
        g = 0;
        b = colorStep;
        colorStep++;
      } else {
        if (is_red == true && is_blue == false && is_green == false && is_green_2 == false && is_yellow == false && is_yellow_2 == false) {
          is_red = false;
          is_blue = true;
          colorStep = 255;
        }
      }
    }

    // PURPLE -> BLUE
    if (is_blue == true) {
      colour_state = 1;
      if (colorStep >= 0) {
        r = colorStep;
        g = 0;
        b = 255;
        colorStep--;
      } else {
        if (is_blue == true && is_red == false && is_green == false && is_green_2 == false && is_yellow == false && is_yellow_2 == false) {
          is_blue = false;
          is_green = true;
          colorStep = 0;
        }
      }
    }

    // BLUE -> TURQUOISE
    if (is_green == true) {
      colour_state = 2;
      if (colorStep <= 255) {
        r = 0;
        g = colorStep;
        b = 255;
        colorStep++;
      } else {
        if (is_green == true && is_red == false && is_blue == false && is_green_2 == false && is_yellow == false && is_yellow_2 == false) {
          is_green = false;
          is_green_2 = true;
          colorStep = 255;
        }
      }
    }

    // TURQUOISE -> GREEN
    if (is_green_2 == true) {
      colour_state = 3;
      if (colorStep >= 0) {
        r = 0;
        g = 255;
        b = colorStep;
        colorStep--;
      } else {
        //Serial.println(is_green_2);
        if (is_green_2 == true && is_red == false && is_blue == false && is_green == false && is_yellow == false && is_yellow_2 == false) {
          is_green_2 = false;
          is_yellow = true;
          colorStep = 0;
        }
      }
    }

    // GREEN -> YELLOW
    if (is_yellow == true) {
      colour_state = 4;
      if (colorStep <= 255) {
        r = colorStep;
        g = 255;
        b = 0;
        colorStep++;
      } else {
        if (is_yellow == true && is_red == false && is_blue == false && is_green_2 == false && is_green_2 == false && is_yellow_2 == false) {
          is_yellow = false;
          is_yellow_2 = true;
          colorStep = 255;
        }
      }
    }

    // YELLOW -> RED
    if (is_yellow_2 == true) {
      colour_state = 5;
      if (colorStep >= 0) {
        r = 255;
        g = colorStep;
        b = 0;
        colorStep--;
      } else {
        if (is_yellow_2 == true && is_red == false && is_blue == false && is_green_2 == false && is_green_2 == false && is_yellow == false) {
          is_yellow_2 = false;
          is_red = true;
          colorStep = 0;
        }
      }
    }

  }

  for (int x = 0; x < LED_COUNT; x++) {
    leds[x] = CRGB(r, g, b);
  }

  delay(delay_speed);
  if (!paused) {
    FastLED.show();
  }


}
